! ===================================================================================================\n
! MODULE        : tests_string
!
! CONTACT       : orchidee-help _at_ listes.ipsl.fr
!
! LICENCE       : IPSL (2006)
! This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
!
!>\BRIEF        
!!
!!\n DESCRIPTION : 
!!
!! RECENT CHANGE(S) : None
!!
!! REFERENCE(S) :
!!
!! SVN          :
!! $HeadURL: svn://forge.ipsl.jussieu.fr/orchidee/branches/ORCHIDEE-MICT/ORCHIDEE/src_sechiba/hydrol.f90 $
!! $Date: 2018-10-09 11:43:16 +0200 (Tue, 09 Oct 2018) $
!! $Revision: 5477 $
!! \n
!_ ===============================================================================================\n
MODULE tests_string

  USE string

  IMPLICIT NONE

  PRIVATE
  PUBLIC :: tests_string_main

  !
  ! variables used inside this module : declaration and initialisation
  !

CONTAINS

!! ================================================================================================================================
!! SUBROUTINE 	: tests_string_main
!!
!>\BRIEF         
!!
!! DESCRIPTION :
!!
!! MAIN OUTPUT VARIABLE(S) : 
!!
!! REFERENCE(S) : 
!!
!! FLOWCHART    : None
!! \n
!_ ================================================================================================================================
  SUBROUTINE tests_string_main()

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables

  !_ ======================================================================================================
    CALL tests_string_endswith()
    CALL tests_string_not_endswith()
    CALL tests_string_countsubstring()
    CALL tests_string_countsubstring_space
    CALL tests_string_split()
    CALL tests_string_split_with_empty()
    CALL tests_string_split_with_free_empty()
          
  END SUBROUTINE tests_string_main
  
!! ================================================================================================================================
!! SUBROUTINE 	: tests_string_endswith
!!
!>\BRIEF         
!!
!! DESCRIPTION :
!!
!! MAIN OUTPUT VARIABLE(S) : 
!!
!! REFERENCE(S) : 
!!
!! FLOWCHART    : None
!! \n
!_ ================================================================================================================================
  SUBROUTINE tests_string_endswith()

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables
    CHARACTER(LEN=:), ALLOCATABLE :: test_title
    LOGICAL :: is_ending

  !_ ======================================================================================================
    WRITE(*,*) "========================================================================"
    test_title = "tests_strind_endswith" 
    WRITE(*,*) "Test "//test_title

    is_ending = string_endswith('somethingtosee.list', '.list')

    IF ( is_ending ) THEN 
       WRITE(*,*) "Test "//test_title//": Successful"
    ELSE
       WRITE(*,*) "Test "//test_title//": failed"
       WRITE(*,*) "Expected:", .TRUE.
       WRITE(*,*) "Found:", is_ending 
    ENDIF
          
  END SUBROUTINE tests_string_endswith



  SUBROUTINE tests_string_not_endswith()

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables
    CHARACTER(LEN=:), ALLOCATABLE :: test_title
    LOGICAL :: is_ending
  !_ ======================================================================================================
    WRITE(*,*) "========================================================================"
    test_title = "tests_string_not_endswith" 
    WRITE(*,*) "Test "//test_title

    is_ending = string_endswith('maybe.list.somethingtosee.else', '.list')

    IF ( .NOT. is_ending ) THEN 
       WRITE(*,*) "Test "//test_title//": Successful"
    ELSE
       WRITE(*,*) "Test "//test_title//": failed"
       WRITE(*,*) "Expected:", .FALSE.
       WRITE(*,*) "Found:", is_ending 
    ENDIF
          
  END SUBROUTINE tests_string_not_endswith

  
!! ================================================================================================================================
!! SUBROUTINE 	: tests_string_countsubstring
!!
!>\BRIEF         
!!
!! DESCRIPTION :
!!
!! MAIN OUTPUT VARIABLE(S) : 
!!
!! REFERENCE(S) : 
!!
!! FLOWCHART    : None
!! \n
!_ ================================================================================================================================
  SUBROUTINE tests_string_countsubstring

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables
    CHARACTER(LEN=:), ALLOCATABLE :: test_title
    INTEGER :: found

  !_ ======================================================================================================
    WRITE(*,*) "========================================================================"
    test_title = "tests_string_countsubstring" 
    WRITE(*,*) "Test "//test_title

    found = countsubstring("hello.nc something.nc ", ".nc") 

    IF ( found .EQ. 2 ) THEN 
       WRITE(*,*) "Test "//test_title//": Successful"
    ELSE
       WRITE(*,*) "Test "//test_title//": failed"
       WRITE(*,*) "Expected: 2"
       WRITE(*,*) "Found:", found
    ENDIF
          
  END SUBROUTINE tests_string_countsubstring

  SUBROUTINE tests_string_countsubstring_space

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables
    CHARACTER(LEN=:), ALLOCATABLE :: test_title
    INTEGER :: found

  !_ ======================================================================================================
    WRITE(*,*) "========================================================================"
    test_title = "tests_string_countsubstring_space" 
    WRITE(*,*) "Test "//test_title

    found = countsubstring("hello.nc something.nc   ", " ") 

    IF ( found .EQ. 4 ) THEN 
       WRITE(*,*) "Test "//test_title//": Successful"
    ELSE
       WRITE(*,*) "Test "//test_title//": failed"
       WRITE(*,*) "Expected: 4"
       WRITE(*,*) "Found:", found
    ENDIF
          
  END SUBROUTINE tests_string_countsubstring_space
  
  
!! ================================================================================================================================
!! SUBROUTINE 	: tests_string_split
!!
!>\BRIEF         
!!
!! DESCRIPTION :
!!
!! MAIN OUTPUT VARIABLE(S) : 
!!
!! REFERENCE(S) : 
!!
!! FLOWCHART    : None
!! \n
!_ ================================================================================================================================
  SUBROUTINE tests_string_split

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables
    CHARACTER(LEN=:), ALLOCATABLE :: test_title
    CHARACTER(LEN=300), ALLOCATABLE, DIMENSION(:) :: foundnames
    INTEGER :: ier

  !_ ======================================================================================================
    WRITE(*,*) "========================================================================"
    test_title = "tests_string_split" 
    WRITE(*,*) "Test "//test_title

    CALL string_split("hello.nc something.nc", " ", foundnames, ier) 

    IF (    ier .EQ. 0 .AND.  &
            TRIM(foundnames(1)) .EQ. 'hello.nc' .AND. &
            TRIM(foundnames(2)) .EQ. 'something.nc' ) THEN 
       WRITE(*,*) "Test "//test_title//": Successful"
    ELSE
       WRITE(*,*) "Test "//test_title//": failed"
       WRITE(*,*) "Expected: hello.nc something.nc"
       WRITE(*,*) "Found:", foundnames
       WRITE(*,*) "Found: ier=", ier
    ENDIF
          
  END SUBROUTINE tests_string_split


  SUBROUTINE tests_string_split_with_empty

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables
    CHARACTER(LEN=:), ALLOCATABLE :: test_title
    CHARACTER(LEN=300), ALLOCATABLE, DIMENSION(:) :: foundnames
    INTEGER :: ier

  !_ ======================================================================================================
    WRITE(*,*) "========================================================================"
    test_title = "tests_string_split_with_empty" 
    WRITE(*,*) "Test "//test_title

    CALL string_split("hello.nc something.nc  ", " ", foundnames, ier) 

    IF (    ier .EQ. 0 .AND.  &
            TRIM(foundnames(1)) .EQ. 'hello.nc' .AND. &
            TRIM(foundnames(2)) .EQ. 'something.nc' .AND. &
            TRIM(foundnames(3)) .EQ. '' .AND. &
            TRIM(foundnames(4)) .EQ. '' ) THEN 
       WRITE(*,*) "Test "//test_title//": Successful"
    ELSE
       WRITE(*,*) "Test "//test_title//": failed"
       WRITE(*,*) "Expected: hello.nc, something.nc, , "
       WRITE(*,*) "Found:", foundnames
       WRITE(*,*) "Found: ier=", ier
    ENDIF
          
  END SUBROUTINE tests_string_split_with_empty

  SUBROUTINE tests_string_split_with_free_empty

    !! 0. Variable and parameter declaration

    !! 0.1 Input variables
    CHARACTER(LEN=:), ALLOCATABLE :: test_title
    CHARACTER(LEN=300), ALLOCATABLE, DIMENSION(:) :: foundnames
    INTEGER :: ier

  !_ ======================================================================================================
    WRITE(*,*) "========================================================================"
    test_title = "tests_string_split_with_free_empty" 
    WRITE(*,*) "Test "//test_title

    CALL string_split(" hello.nc   something.nc   another_file.nc ", " ", foundnames, ier) 

    IF (    ier .EQ. 0 .AND.  &
            TRIM(foundnames(1))  .EQ. '' .AND. &
            TRIM(foundnames(2))  .EQ. 'hello.nc' .AND. &
!            TRIM(foundnames(3))  .EQ. '' .AND. &
            TRIM(foundnames(3))  .EQ. '' .AND. &
            TRIM(foundnames(4))  .EQ. '' .AND. &
            TRIM(foundnames(5))  .EQ. 'something.nc' .AND. &
!            TRIM(foundnames(7))  .EQ. '' .AND. &
            TRIM(foundnames(6))  .EQ. '' .AND. &
            TRIM(foundnames(7))  .EQ. '' .AND. &
            TRIM(foundnames(8)) .EQ. 'another_file.nc' .AND. &
            TRIM(foundnames(9)) .EQ. '' ) THEN 
       WRITE(*,*) "Test "//test_title//": Successful"
    ELSE
       WRITE(*,*) "Test "//test_title//": failed"
       WRITE(*,*) "Expected: hello.nc, something.nc another_file.nc, , "
       WRITE(*,*) "Found:", foundnames
       WRITE(*,*) "Found: ier=", ier
    ENDIF
          
  END SUBROUTINE tests_string_split_with_free_empty
  
END MODULE tests_string
